# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
    def self.get_file(dir_s4u_name,s4u_name,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        if File.exist?(file_name_full)
            file= File.new(file_name_full,"r")
            str=file.readlines
            file.close
            return str.collect{|s| s.chomp}
        end
        return false
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
    def self.set_file(dir_s4u_name,s4u_name,list,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        file= File.new(file_name_full, mode: 'w:UTF-8')
        str=list.join("\n")
        file.syswrite str
        file.close
        return true
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
	module S4u_export_scenes
		def self.get_setting()
            if !(@last_setting && @last_setting[0].class==Hash)
                if s=S4U::get_file(Dir_s4u_name,NAME)
                    s.compact!
                    @last_setting=[]
                    (0..@max_recent).each{|i| @last_setting << JSON.parse(s[i]) if s[i]}
                    self.get_setting()
                    if @last_setting && @last_setting[0]
                        @scenes=@last_setting[0]['scenes']
                        @options=@last_setting[0]['options']
                    end

                    return @last_setting
                end
			end
            return nil
             rescue=>error
            p error,error.backtrace.join("\n")
        end
        def self.save_setting(s)
            setting= {'options'=>s[0],'scenes'=> s[1]}
            @last_setting=[] if !@last_setting
            @last_setting.unshift(setting) if @last_setting.empty? || @last_setting[0].keys.any?{|e| @last_setting[0][e]!=setting[e]}
            if !S4U::set_file(Dir_s4u_name,NAME, @last_setting.collect{|s| s.to_json}[0..@max_recent])
                puts "error save setting"
            end
        end
        def self.create_dialog
            if !@dialog_export
                @dialog_export = UI::HtmlDialog.new(
                {
                    :dialog_title => Strings["Manage Scenes"],
                    :preferences_key => "suforyou.export_scenes",
                    :resizable => true,
                    :scrollable => true,
                    :width => 560,
                    :height => 600,
                    :min_width => 250,
                    :min_height => 200,
                    :style => UI::HtmlDialog::STYLE_DIALOG
                })
                @dialog_export.center;
            end
            pages=Sketchup.active_model.pages
            view=Sketchup.active_model.active_view
            if !@options
                @options = {
                    "vpwidth" => view.vpwidth ,
                    "vpheight"=> view.vpheight ,
                    "vpline_scale"=> UI.scale_factor ,
                    "width" => view.vpwidth ,
                    "height"=> view.vpheight ,
                    "line_scale"=> 1 ,
                    "view_size"=> false ,
                    "lock_ratio"=> false ,
                    "transparent"=> false ,
                    "jpg"=> true ,
                    "png"=> false ,
                    "antialias" => true ,
                    "compression" => 70 ,
                    "prefix"=> '<name>'
                }
            end
            scenes=[]
            if Sketchup.version.to_i>17
                pages.to_a.each_index{|i| scenes<<[pages[i].persistent_id,pages[i].name,i,i]}
			else
				pages.to_a.each_index{|i| scenes<<[i,pages[i].name,i,i]}
			end
			@dialog_export.add_action_callback("load") { |action_context|
				js_command ="scenes=#{scenes.to_a};
                             createScenes(scenes);
                             options=#{@options.to_json};
                             set_options(options);
                             "
				@dialog_export.execute_script(js_command)
                if @scenes
                    @dialog_export.execute_script("set_list_preview(#{@scenes})")
                end
			}
			@dialog_export.add_action_callback("export") { |action_context, scenes, options|
				self.export(scenes,JSON.parse(options))
			}
            @dialog_export.add_action_callback("cancel") { |action_context, scenes, options|
				@scenes,@options=scenes,JSON.parse(options)
                @dialog_export.close
			}
			@dialog_export.set_html(get_html_export_scenes(@scenes))
			@dialog_export.show
        end
        def self.export(scenes,options)
            @options=options
            @scenes=scenes
            self.save_setting([options,scenes])
			model=Sketchup.active_model
			view=model.active_view
			pages=model.pages
            if  pages.length<=0
				p Strings["No Scene!"]
				return
			end
            pages_hash={}
            if Sketchup.version.to_i>17
                pages.to_a.each_index{|i| pages_hash[pages[i].persistent_id.to_s]=pages[i]}
			else
				pages.to_a.each_index{|i| pages_hash[i.to_s]=pages[i]}
			end
			namefile=File.basename(model.path,".skp").strip
            path=UI.select_directory(title: Strings["Select Image Directory"])
            return if !path
			showtransition=model.options["PageOptions"]["ShowTransition"]

			model.start_operation TOOL,true,false,false
				model.options["PageOptions"]["ShowTransition"]=false
				selected_page=pages.selected_page.name
				@replace_all= IDNO
                ['jpg','png'].each{|ext|
                    next if !options[ext]
                    scenes.each_index{|i|
                        page=pages_hash[scenes[i][0].slice(scenes[i][0].index("_")+1,scenes[i][0].length)]
                        next if !page
                        path_file = File.join(path.clone,scenes[i][1] + '.' + ext)
                        if File.exist?(path_file) && (@replace_all==IDNO)
                            @replace_all= (@scenes.length>1) ?(IDNO):(IDYES)
                            result = UI.messagebox( File.basename(path_file)+ " " + Strings["already exist.\nDo you want to replace it?"],MB_YESNOCANCEL )
                            if result == IDNO
                                next
                            elsif result == IDCANCEL
                                return
                            elsif (result == IDYES) && (@replace_all==IDNO)
                                @replace_all=UI.messagebox(Strings["Do you want to replace all?"],MB_YESNO)
                            end
                        end
                        Sketchup.set_status_text(Strings["Exporting"] +" ... "+ path_file)
                        puts (Strings["Exporting"] +" ... "+ path_file)
                        model.active_view.invalidate
                        pages.selected_page = page
                        keys = {
                            :filename => path_file,
                            :width => options['width'].to_i,
                            :height => options['height'].to_i,
                            :antialias => options['antialias'],
                            :compression => (options['compression'].to_i*0.01),
                            :transparent => options['transparent'],
                            :scale_factor => options['line_scale'].to_f
                            }
                        view.write_image keys
                    }
				}
				pages.selected_page=pages.find{|p| p.name==selected_page}
				model.options["PageOptions"]["ShowTransition"]=showtransition
			model.commit_operation
			rescue => error
				p error
				p error.backtrace.join("\n")
				model.options["PageOptions"]["ShowTransition"]=showtransition
				model.abort_operation
		end
		def self.manage_scenes()
			model=Sketchup.active_model
			view=model.active_view
			pages=model.pages
			if  pages.length<=0
				UI.messagebox Strings.GetString("No Scene!")
				return
			end
			scenes=pages.collect{|p| p.name}
            if !@dialog
                @dialog = UI::HtmlDialog.new(
                {
                    :dialog_title => Strings["Manage Scenes"],
                    :preferences_key => "suforyou.extension.export_scenes",
                    :resizable => true,
                    :scrollable => true,
                    :width => 320,
                    :height => 330,
                    :min_width => 250,
                    :min_height => 200,
                    :style => UI::HtmlDialog::STYLE_DIALOG
                })
                @dialog.center
            end
			@dialog.add_action_callback("load") { |action_context|
				js_command ="scenes=#{scenes.to_a};
                             createScenes(scenes);"
				@dialog.execute_script(js_command)
			}
			@dialog.add_action_callback("callback") { |action_context, scenes_callback|
				set_scenes(scenes_callback)
			}

			@dialog.set_html(get_html(scenes))
			@dialog.show
		end
		def self.set_scenes(scenes_callback)
			model=Sketchup.active_model
			scenes_name=scenes_callback.collect{|p| p[1]}
			scenes_index=scenes_callback.collect{|p| p[0].to_i}
			showtransition=model.options[0][0]
			model.start_operation  Strings["Manage Scenes"],true,false,false
				pages=model.pages
				nochange_index=true
				scenes_callback.each_index { |i|
					if i!= scenes_callback[i][0].to_i
						nochange_index=false
						break
					end
				}
				if nochange_index
					scenes_callback.each_index { |i|
						pages[i].name=scenes_callback[i][1] if scenes_callback[i][1]!=pages[i].name
					}
				else
					model.options[0][0]=false
					old_index=pages.to_a.index(pages.selected_page)
					scenes_callback.each_index{|i|scenes_callback[i]<<i}
					scenes_callback.each_index{|i|
						if scenes_callback[i][0].to_i==old_index
							old_index=scenes_callback[i][2].to_i
							break
						end
					}
					scenes_callback.each_index{|i|
						if scenes_callback[i][0].to_i!=i
							model.pages.selected_page=model.pages[scenes_callback[i][0].to_i]
								page=model.pages.add(scenes_callback[i][1],65535,i)
								if page
									copy_scene(model.pages[scenes_callback[i][0].to_i+1],page)
								end
								model.pages.erase(model.pages[scenes_callback[i][0].to_i+1])
								(i+1..(scenes_callback.length-1)).each{|j|
									if scenes_callback[j][0].to_i.between?(0,scenes_callback[i][0].to_i)
										scenes_callback[j][0]=scenes_callback[j][0].to_i+1
									end
								}
						elsif scenes_callback[i][1]!=model.pages[scenes_callback[i][2]].name
							model.pages[scenes_callback[i][2]].name=scenes_callback[i][1]
						end
					}
					model.pages.selected_page=model.pages[old_index]
					model.options[0][0]=showtransition
				end
			model.commit_operation
			rescue => error
				p error
				p error.backtrace.join("\n")
				model.options[0][0]=showtransition
				model.abort_operation
		end
		def self.copy_scene(scene_source,scene_dis)
			scene_dis.delay_time = scene_source.delay_time
			scene_dis.description=scene_source.description
			if (Sketchup.version.to_i>=18)
				(scene_dis.include_in_animation=scene_source.include_in_animation? ) if scene_source.include_in_animation?
			end
			scene_dis.transition_time=scene_source.transition_time
			scene_dis.use_axes=scene_source.use_axes?
			scene_dis.use_camera=scene_source.use_camera?
			scene_dis.use_hidden=scene_source.use_hidden?
			scene_dis.use_hidden_layers=scene_source.use_hidden_layers?

			scene_dis.use_rendering_options=scene_source.use_rendering_options?
			scene_dis.use_section_planes=scene_source.use_section_planes?
			scene_dis.use_shadow_info=scene_source.use_shadow_info?
			scene_dis.use_style=scene_source.use_style?
			if scene_source.use_axes?
				scene_dis.axes.set(scene_source.axes.origin,scene_source.axes.xaxis,scene_source.axes.yaxis,scene_source.axes.zaxis)
			end
			scene_dis.use_camera=scene_source.use_camera?
			scene_dis.use_hidden=scene_source.use_hidden?
			scene_dis.use_hidden_layers=scene_source.use_hidden_layers?
			scene_dis.use_rendering_options=scene_source.use_rendering_options?
			scene_dis.use_section_planes=scene_source.use_section_planes?
			scene_dis.use_shadow_info=scene_source.use_shadow_info?
			scene_dis.use_style=scene_source.use_style?

		end
		def self.main(mode=0)
            @max_recent=9
			if mode==0
                self.create_dialog
			else
				self.manage_scenes
			end
		end
		def self.get_html(scenes)
		html=
        <<EOS
			<!DOCTYPE HTML>
			<html>
			<head>
			<style>
				.input_true{
					width: 70% ;
					height: 25px ;
					border-radius: 2px;
					border-style: solid;
					border-width: 1px;
					background-color: #cfe1ee;
					text-indent:4px;
					list-style-position: outside;
					line-height: 1.8;
					margin :3px;
				}
				.input_false {
					height: 25px;
					width: 70% ;
					margin :3px;
					border-radius: 2px;
					border-style: solid;
					border-width: 1px;
					text-indent:4px;
					list-style-position: outside;
					line-height: 1.8;
				}


			</style>
            <link  href='#{Dir_s4u_name}/vendor/modus/modus.min.css' rel='stylesheet'>
            <script src='#{Dir_s4u_name}/vendor/modus/jquery.js'></script>
            <script src='#{Dir_s4u_name}/vendor/modus/bootstrap.bundle.min.js'></script>
			<script>
				var clicked=false
				var scenes = [];
				var out_scenes = [];
				var list;
				var scene;
				function allowDrop(ev) {
					ev.preventDefault();
				}
				function mouseover_scene(ev,id)
				{
					if (ev.shiftKey)
					{
					   if(ev.target.tagName=='LI' )
                        {
                           set_status(ev,id,'true');
                        }
					}
					else
					{
                        if((ev.ctrlKey) && (ev.target.tagName=='LI' ))
						{
                            set_status(ev,id,'false');
                        }
					}
				}
				function dragstart(ev,id)
				{
						if(ev.target.tagName=='LI')
						{
							set_status(ev,id,'true');
						}
				}
				function set_status(ev,id,flag=null)
				{
					if (flag==null)
					{
                        var c= ($('#'+ev.target.id).children("input").attr('class')=='input_false')? 'input_true': 'input_false';
                        $('#'+ev.target.id).children("input").attr('class',c);
                    }
                    else
                    {
                        $('#'+ev.target.id).children("input").attr('class',('input_' + flag ));
                    }
				}
				function mouseup_scene(ev,id)
				{
					if((!ev.shiftKey) && (ev.target.tagName=='LI') )
					{
                        set_status(ev,id);
                    }
				}
				function drop(ev,id)
				{
					var move=[];
					for (i = 0; i < scenes.length; i++)
					{
                        if($('#'+i).children("input").attr('class')=='input_true')
						{
							if(! move.includes(i.toString()))
							{
                                move.push(i.toString());
                            }
						}
					}
					for(i=0;i<move.length;i++)
					{
						var list=document.getElementById('scenes_list');
						list.insertBefore(document.getElementById(move[i]),document.getElementById(id));
					}
					resize();
				}
				function clear_all()
				{
                    $("#scenes_list li input").filter(function() {
                        $(this).attr('class','input_false');
                    });

				}
                function move_bottom()
				{
                    var move=[];
					for (i = 0; i < scenes.length; i++)
					{
                        if($('#'+i).children("input").attr('class')=='input_true')
						{
							if(! move.includes(i.toString()))
							{
                                move.push(i.toString());
                            }
						}
					}
					for(i=0;i<move.length;i++)
					{
                        $("#scenes_list").append($("#"+move[i]));
					}
					resize();
				}
                function move_top()
				{
                    var move=[];
					for (i = 0; i < scenes.length; i++)
					{
                        if($('#'+i).children("input").attr('class')=='input_true')
						{
							if(! move.includes(i.toString()))
							{
                                move.push(i.toString());
                            }
						}
					}
					for(i=move.length-1;i>=0;i--)
					{
                        $("#scenes_list").prepend($("#"+move[i]));
					}
					resize();
				}
				function select_all()
				{
                    $("#scenes_list li input").filter(function() {
                        $(this).attr('class','input_true');
                    });
				}
				function createScenes(s)
				{
					for (i = 0; i < s.length; i++)
					{
						createScene(s[i],i);
					}
				}
				function createScene(text,id) {
                    var list = document.getElementById('scenes_list');
					var li = document.createElement('li');
					var input = document.createElement('input');
					li.appendChild(input);
					list.appendChild(li);
                    input.setAttribute('type','text');
					input.setAttribute('value',text);
					input.setAttribute('class','input_false');
					li.setAttribute('id',id);
					li.onmouseup=function(){mouseup_scene(event,id)};
					li.ondrop=function(){drop(event,id)};
					li.ondragover=function(){allowDrop(event,id)};
					li.ondragstart=function(){dragstart(event,id)};
					li.onmouseover=function(){mouseover_scene(event,id)};
					li.draggable=true;

				}
				function reset()
				{
                    $("#scenes_list").empty();
					createScenes(scenes);
				}
				function apply()
				{
					out_scenes=[];
                    $("#scenes_list li input").filter(function() {
                        $(this).attr('class','input_false');
                        out_scenes.push( [$(this).parent().attr('id'),$(this).val()]);
                    });
					sketchup.callback(out_scenes, {onCompleted:update()});$(this)
				}
				function update()
				{
					scenes=[];
					for (i = 0; i < out_scenes.length; i++)
					{
						scenes.push(out_scenes[i][1]);
					}
					reset();
				}
				function rename()
				{
					var move=[];
					for (i = 0; i < scenes.length; i++)
					{
                        if($('#'+i).children("input").attr('class')=='input_true')
						{
							if(! move.includes(i.toString()))
							{	move.push(i.toString());}
						}
					}
					var name=document.getElementById('name').value;
					name= (name=='')? '' : name;
					var index = document.getElementById('index').value;
					var index1=false;

					if (index.startsWith('\#'))
					{
						index1=true;
						index= (index.split('\#')[1]).trim();
					}
					index= ((index=='')||isNaN(index))? 1 : Number(index);
					for(i=0;i<move.length;i++)
					{
						var text=(index + i);
						if (index1==true)
						{
							var t='';
							for(j1=0;j1<(4-text.toString().length);j1++)
							{
								t+='0';
							};
							text=t + text;
						}
                        $('#'+move[i]).children("input").val( name + text);
					}
				}
                function resize()
                {
                    document.getElementById('div').style.height= (window.innerHeight-100)+'px';
                }
                function context(event) {
                    event.preventDefault();
                }
                function keyright(event) {
                    if(event.shiftKey && (event.key=='F10' || event.keyCode==121 ))
                    {
                        event.preventDefault();
                    }
                }
			</script>
			</head>
			<body onresize='resize()' oncontextmenu='context(event)' onkeydown='keyright(event)' >
            <div class="container mt-2">
                <div class="row" id='menu'>
                    <div class="col-9">
                        <button class="px-2 btn btn-outline-primary" id='select_all' onclick='select_all()'>#{Strings["Select All"]} </button>
                        <button class="px-2 btn btn-outline-primary" id='unselect_all' onclick='clear_all()'>#{Strings["Clear All"]}</button>
                        <button class="px-2 btn btn-outline-primary" id='move_top' onclick='move_top()'>#{Strings["Top"]}</button>
                        <button class="px-2 btn btn-outline-primary" id='move_bottom' onclick='move_bottom()'>#{Strings["Bottom"]}</button>
                        <button class="px-2 btn btn-outline-primary" id='load_all' onclick='reset()'>#{Strings["Reset"]}</button>
                    </div>
                    <div class="col-3 text-right">
                        <button class="btn btn-primary" id='Apply' onclick='apply()'>#{Strings["Apply"]}</button>
                    </div>
                </div>
                <div class="row my-1" id='rename'>
                    <div class="col-9 pr-1">
                        <input type='text' class=" form-control" id='name' placeholder='Rename Selected Scenes' oninput='rename()' > </input>
                    </div>
                    <div class="col-3 pl-0">
                        <input type='text' class="form-control" id='index' placeholder='Start index' oninput='rename()'></input>
                    </div>
                </div>
                <div class="border overflow-auto" id='div' >
                    <ol class=" mt-2" id="scenes_list" >
                    </ol>
                </div>
            </div>
                <script>
                    sketchup.load();
                    resize();
                </script>

			</body>
			</html>
EOS
		end
		def self.get_html_export_scenes(scenes)
            html=
            <<EOS
            <!DOCTYPE HTML>
            <html>
            <head>
            <style>
            </style>
            <link  href='#{Dir_s4u_name}/vendor/modus/modus.min.css' rel='stylesheet'>
            <script src='#{Dir_s4u_name}/vendor/modus/jquery.js'></script>
            <script src='#{Dir_s4u_name}/vendor/modus/bootstrap.bundle.min.js'></script>
            <script>
                function context(event) {
                    event.preventDefault();
                }
                function keyright(event) {
                    if(event.shiftKey && (event.key=='F10' || event.keyCode==121 ))
                    {
                        event.preventDefault();
                    }
                }
            </script>
            </head>
            <body class="bg-panel-background">
                <div class="container">
                    <div class="header">
                        <h4> #{Strings["Select Scenes"]} </h4>
                    </div>
                </div>
                <div class="container" id="container_filter">
                    <div class="row">
                        <div class="col-5" >
                            <div class="form-group">
                                <label for="filter">#{Strings["Filter"]}</label>
                                <input type="text" class="form-control form-control-sm" id="filter" placeholder=#{Strings["Search.."]}>
                                <div class="custom-control custom-checkbox custom-control-inline mr-1">
                                    <input type="checkbox" class="custom-control-input" id="select_all">
                                    <label class="custom-control-label" for="select_all">#{Strings["Select All"]}</label>
                                </div>
                            </div>
                        </div>
                        <div class="col-2">
                            <div class="form-group">

                            </div>
                        </div>
                        <div class="col-5">
                            <div class="form-group">
                                <label for="prefix">#{Strings["Prefix Name"]}</label>
                                <input type="text" class="form-control form-control-sm " id="prefix" value="<name>">
								<label class="prefix">
									&ltname&gt
                                </label>
                                <label class="prefix">
									&#60;index&#62;
                                </label>
                                <label class="prefix">
									&#60;number&#62;
								</label>
							</div>
                        </div>
                    </div>
                </div>
                <div class="container" id="container_list">
                    <div class="row" >
						<div class="col-5">
							<h6>#{Strings["List Scenes"]}</h6>
							<div class="form-group border overflow-auto" style="height:180px;">
								<ul class="list-group list-group-condensed" id="list_scenes">

								</ul>
							</div>
						</div>
                        <div class="col-2 text-center mt-4">

							<div class="form-group mb-3" >
								<button class="btn btn-outline-primary " id="select_a">
									<span style='font-size:12px;'>&#62;&#62;</span>
								</button>
							</div>
                            <div class="form-group mb-3">
                                <button class="btn btn-outline-primary" id="select">
									<span style='font-size:12px;'>&#62;</span>
								</button>
                            </div>
							<div class="form-group mb-3">
								<button class="btn btn-outline-primary" id="deselect">
									<span style='font-size:12px;'>&#60;</span>
								</button>
							</div>
							<div class="form-group">
								<button class="btn btn-outline-primary" id="deselect_a">
									<span style='font-size:12px;'>&#60;&#60;</span>
								</button>
							</div>
                        </div>
						<div class="col-5">
							<h6>#{Strings["List Preview"]}</h6>
							<div class="form-group overflow-auto border" style="height:180px;">
								<ul class="list-group list-group-condensed" id="list_preview" value='0'>

								</ul>
							</div>
						</div>
                    </div>
                </div>
                <div class="container" id="container_image">
                    <div class="image mb-3">
                        <h4>#{Strings["Image"]}</h4>
						<div class="row">
							<div class="col-4" >
								<div class="input-group input-group-sm mb-1">
									<div class="input-group-prepend " >
										<span class="input-group-text border-0 bg-panel-background" style="width:75px;">#{Strings["Width"]}</span>
									</div>
									<input type="text" class="form-control" id="width" placeholder="pixels">
								</div>
								<div class="input-group input-group-sm mb-1" >
									<div class="input-group-prepend ">
										<span class="input-group-text border-0 bg-panel-background" style="width:75px;">#{Strings["Height"]}</span>
									</div>
									<input type="text" class="form-control" id="height" placeholder="pixels">
								</div>
								<div class="input-group input-group-sm mb-1">
									<div class="input-group-prepend ">
										<span class="input-group-text border-0 bg-panel-background" style="width:75px;">#{Strings["Line Scale"]}</span>
									</div>
									<input type="text" class="form-control" id="line_scale" placeholder=#{UI.scale_factor}>
								</div>
							</div>
							<div class="col-4" >
								<div class="custom-control custom-checkbox"  id="view_size">
									<input type="checkbox"  class="custom-control-input" id="view_size_check" >
									<label class="custom-control-label" for="view_size_check">#{Strings["Use View Size"]}</label>
								</div>
								<div class="custom-control custom-checkbox"  id="lock_ratio">
									<input type="checkbox"  class="custom-control-input" id="lock_ratio_check" >
									<label class="custom-control-label" for="lock_ratio_check">#{Strings["Lock ratio"]}</label>
								</div>
								<div class="custom-control custom-checkbox"  id="transparent">
									<input type="checkbox"  class="custom-control-input" id="transparent_check" >
									<label class="custom-control-label" for="transparent_check">#{Strings["Transparent Bg"]}</label>
								</div>
							</div>
							<div class="col-4" >
								<div class="custom-control custom-checkbox custom-control-inline mr-2"  id="jpg">
									<input type="checkbox"  class="custom-control-input" id="jpg_check" >
									<label class="custom-control-label" for="jpg_check">jpg</label>
								</div>
								<div class="custom-control custom-checkbox custom-control-inline"  id="png">
									<input type="checkbox"  class="custom-control-input" id="png_check" >
									<label class="custom-control-label" for="png_check">png</label>
								</div>
								<div class="custom-control custom-checkbox custom-control-inline mb-1"  id="antialias">
									<input type="checkbox"  class="custom-control-input" id="antialias_check" >
									<label class="custom-control-label" for="antialias_check">#{Strings["Anti-alias"]}</label>
								</div>
								<div class="custom-control-inline">
									<label for="compression_check">#{Strings["Quality"]}</label>
									<input type="range" class="custom-range mt-1 ml-1" value="100" min="0" max="100" step="0.5" id="compression">
								</div>
							</div>
						</div>
                    </div>
                </div>
                <div class="container" id="container_footer">
                    <div class="modal-footer pr-0">
                            <button type="button" class="btn btn-outline-primary" id="cancel">#{Strings["Cancel"]}</button>
                            <button type="button" class="btn btn-primary mr-0" id="export">#{Strings["Export"]}</button>
                    </div>
                </div>
            <script>
                function parse_scene_name(scene)
                {
                    prefix=$("#prefix").val();
                    prefix=prefix.replace("<name>",scene[1]);
                    if( prefix.includes("<#index>"))
                    {
                        number=1 + Number(scene[2]);
                        s = '0000' + number.toString();
                        prefix=prefix.replace("<#index>",s.slice(s.length-4));
                    }
                    prefix=prefix.replace("<index>",1 + Number(scene[2]));
                    if( prefix.includes("<#number>"))
                    {
                        number=1 + Number(scene[3]);
                        s = '0000' + number.toString();
                        prefix=prefix.replace("<#number>",s.slice(s.length-4));
                    }
                    prefix=prefix.replace("<number>",1 + Number(scene[3]));
                    return prefix;
                }
                function add_li(list,scene)
                {
                    var name= parse_scene_name(scene);
                    $(list).append("<li><div><input></input><label></label></div><span>" + name + "</span></li>");
                    $(list + " li div input:last").attr({'type': 'checkbox','class': 'custom-control-input','id': 'input_'+ scene[0]});
                    $(list + " li div label:last").attr({'class': 'custom-control-label','for': 'input_' + scene[0]});
                    $(list + " li div:last").attr('class','custom-control custom-checkbox');
                    $(list + " li:last").attr({'class': 'list-group-item','id': scene[0]});
                    $(list + " li:last").prop({'index': scene[2],'number': scene[3],'name': scene[1]});
                }
				function createScenes(scenes)
				{
                    for(i=0;i<scenes.length;i++)
                    {
                        add_li("#list_scenes",scenes[i]);
                    }
				}
                function set_options(options)
				{
                    $("#width").val(options["width"]) ;
                    $("#height").val(options["height"]) ;
                    $("#line_scale").val(options["line_scale"]) ;
                    $("#view_size_check").prop('checked',options["view_size"]) ;
                    $("#lock_ratio_check").prop('checked',options["lock_ratio"]) ;
                    $("#transparent_check").prop('checked',options["transparent"]) ;
                    $("#jpg_check").prop('checked',options["jpg"]) ;
                    $("#png_check").prop('checked',options["png"]) ;
                    $("#antialias_check").prop('checked',options["antialias"]) ;
                    $("#compression").val(options["compression"]) ;
                    $("#prefix").val(options["prefix"]);
                    ratio=Number(options["vpheight"])/Number(options["vpwidth"]);
                    $("#lock_ratio").prop("checked",((Number(options["height"])/Number(options["width"]))==ratio));
				}
                function set_list_preview(scenes)
				{
                    for(i=0;i<scenes.length;i++)
                    {
                        var value = $("#list_preview").attr("value");
                        add_li("#list_preview",scenes[i]);
                        $("#list_preview").attr('value',Number(value)+1);
                    }
				}
                function update_preview()
                {
                    $("#list_preview li").filter(function() {
                        var value = $(this).prop("number");
                        var id = $(this).attr("id");
                        var name = $(this).prop("name");
                        var index = $(this).prop("index");
                        $(this).children("span").text(parse_scene_name([id,name,index,value]));
                        $("#list_preview").attr('value',Number(value)+1);
                    });
                }
                $(document).ready(function(){
                    $("#filter").on("keyup", function() {
                        var value = $(this).val().toLowerCase();
                        $("#list_scenes li").filter(function() {
                            $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
                        });
                    });
                    $("#prefix").on("keyup", function() {
                        update_preview();
                    });
                    $("#select_all").on("click", function() {
						var list_preview=document.getElementById("list_preview");
							$("#list_scenes li div input").filter(function() {
								if($(this).parent().parent().css('display')!='none')
								{
									$(this).prop("checked",$("#select_all").prop("checked")) ;
								}
							});
                    });
					$("#select_a").on("click", function() {
						$("#list_scenes li div input").filter(function() {
							if($(this).parent().parent().css('display')!='none')
							{
                                var value = $("#list_preview").attr("value");
								var id = "export-" + value + "_" + $(this).parent().parent().attr("id");
                                var name = $(this).parent().siblings("span").html();
                                add_li("#list_preview",[id,name,$(this).parent().parent().prop("index"),value]);
								$("#list_preview").attr('value',Number(value)+1);
							}
						});
                    });
					$("#select").on("click", function() {
                        $("#list_scenes li div input").filter(function() {
							if( $(this).prop("checked"))
							{
                                var value = $("#list_preview").attr("value");
								var id = "export-" + value + "_" + $(this).parent().parent().attr("id");
                                var name = $(this).parent().siblings("span").html();
                                add_li("#list_preview",[id,name,$(this).parent().parent().prop("index"),value]);
								$("#list_preview").attr('value',Number(value)+1);
							}
						});

                    });
					$("#deselect_a").on("click", function() {
							$("#list_preview").empty();
							$("#list_preview").attr('value',0);
                    });
					$("#deselect").on("click", function() {
                        $("#list_preview li div input").filter(function() {
							if( $(this).prop("checked"))
							{
								$(this).parent().parent().remove();
								var value=$("#list_preview").attr("value");
								$("#list_preview").attr('value',Number(value)-1);
							}
						});
					});
                    $(".prefix").on("dblclick", function() {
                        $("#prefix").val($("#prefix").val() + $(this).text().trim());
                        update_preview();
                    });
                    $("#view_size_check").on("click", function() {
                        if ($("#view_size_check").prop("checked"))
                         {
                            $("#height").val(options["vpheight"]);
                            $("#width").val(options["vpwidth"]);
                            $("#line_scale").val(options["vpline_scale"]);
                            $("#lock_ratio_check").prop("checked",true);
                         }

                    });
                    $("#lock_ratio_check").on("click", function() {
                        if( Number(options["vpwidth"])==0 || Number(options["width"])==0)
                            { return ;}
                        ratio=Number(options["vpheight"])/Number(options["vpwidth"]);
                        if ($("#lock_ratio_check").prop("checked"))
                        {
                            $("#height").val(parseInt(Number($("#width").val())*ratio));
                        }
                    });
                    $("#height ,#width, #line_scale").on("keyup", function() {
                        if(($(this).attr("id")=="height") || ($(this).attr("id")=="width"))
                        {
                            if( $(this).val()<1){$(this).val(1); }
                            if ($(this).val()>16000) {$(this).val(16000); }
                        }
                        if(($(this).attr("id")=="line_scale") )
                        {
                            if( $(this).val()<=0){$(this).val(1); }
                        }
                        if( Number(options["vpwidth"])==0 || Number(options["width"])==0)
                        { return ;}
                        ratio=Number(options["vpheight"])/Number(options["vpwidth"]);
                        $("#view_size_check").prop("checked",false);
                        if ($("#lock_ratio_check").prop("checked"))
                        {
                            if($(this).attr("id")=="height")
                            {
                                $("#width").val(parseInt(Number($("#height").val())/ratio));
                            }else if($(this).attr("id")=="width")
                            {
                                $("#height").val(parseInt(Number($("#width").val())*ratio));
                            }
                        }
                        $("#lock_ratio").prop("checked",((Number(options["height"])/Number(options["width"]))==ratio));

                    });
                    $("#height ,#width, #line_scale").on("change", function() {
                        $("#view_size_check").prop("checked",false);

                    });
                    $(window).on("resize", function() {
                        h=  parseInt($("#container_filter").css("height")) +
                            parseInt($("#container_footer").css("height")) +
                            parseInt($("#container_image").css("height")) ;
                        h= window.innerHeight - h- 100;
                        if (h>170 && window.innerHeight>500)
                        {
                            $("#list_scenes").parent().css("height",h + 'px');
                            $("#list_preview").parent().css("height",h + 'px');
                        }
                    });
                    $("#cancel").on("click", function() {
                        var scenes=[];
                        $("#list_preview li").filter(function() {
                            scenes.push([$(this).prop("id"),$(this).children("span").text(),
                                $(this).prop("index"),$(this).prop("value")]);
						});
                        var options = {
                            "width": $("#width").val() ,
                            "height": $("#height").val() ,
                            "line_scale": $("#line_scale").val() ,
                            "view_size": $("#view_size_check").prop('checked') ,
                            "lock_ratio": $("#lock_ratio_check").prop('checked') ,
                            "transparent": $("#transparent_check").prop('checked') ,
                            "jpg": $("#jpg_check").prop('checked') ,
                            "png": $("#png_check").prop('checked') ,
                            "antialias": $("#antialias_check").prop('checked') ,
                            "compression": $("#compression").val() ,
                            "prefix": $("#prefix").val()
                        };
                        sketchup.cancel(scenes,JSON.stringify(options));
                    });
                    $("#export").on("click", function() {
                        var scenes=[];
                        $("#list_preview li").filter(function() {
                            scenes.push([$(this).prop("id"),$(this).children("span").text(),
                                $(this).prop("index"),$(this).prop("value")]);
						});
                        var options = {
                                    "width": $("#width").val() ,
                                    "height": $("#height").val() ,
                                    "line_scale": $("#line_scale").val() ,
                                    "view_size": $("#view_size_check").prop('checked') ,
                                    "lock_ratio": $("#lock_ratio_check").prop('checked') ,
                                    "transparent": $("#transparent_check").prop('checked') ,
                                    "jpg": $("#jpg_check").prop('checked') ,
                                    "png": $("#png_check").prop('checked') ,
                                    "antialias": $("#antialias_check").prop('checked') ,
                                    "compression": $("#compression").val() ,
                                    "prefix": $("#prefix").val()
                                };
                        sketchup.export(scenes,JSON.stringify(options));
                    });
                });
                sketchup.load();
            </script>
            </body>
            </html>
EOS
        end
	end
end